// MAX31855.h:     DLL MAX31855
#pragma once
#include "vsm.hpp"		// -   VSM API  Labcenter Electronics.
#include "Max_conv.h"	//-      .
//#include "Max_graf.h"	//-      .

#define model_key 0x00000000 // -    Labcenter Electronics



#ifndef __AFXWIN_H__
	#error " stdafx.h      PCH"
#endif

#include "resource.h"		//  




//---------------------------------------------------------------------------
//--- C __declspec   dllexport    ,       dll.
//---  IDSIMMODEL *createdsimmodel(...)    ,      (batch mode operation).
// Proteus     ,      ,     (batch mode),   
//    ,   .
//--- CHAR *device -     ,      .    ,   
//   DSIM      DLL,          ,  
//   PRIMTIVE   .
//--- ILICENCESERVER *ils -     (Licence Server).       ,   
// model_key  Labcenter Electronics,     .
//---  : IDSIMMODEL *   -      ,      IDSIMMODEL .
//---------------------------------------------------------------------------
extern "C" IMIXEDMODEL __declspec(dllexport) *createmixedmodel(CHAR *device, ILICENCESERVER *ils)
{
	if(ils->authorize(model_key))		//     createdsimmodel
	{
	//	MessageBoxA(0," !", "!",MB_ICONERROR);
		return new Max_conv;			// -     
	} else {
		MessageBoxA(0,"   : [NULL]!", "!",MB_ICONERROR);
		return NULL;
	}
}
//---------------------------------------------------------------------------
//   PROSPICE,     .     , 
//   ,   .
extern "C" VOID __declspec(dllexport) deletemixedmodel(IMIXEDMODEL *model)
{
	delete (Max_conv *)model;	// -   IDSIMMODEL ,      createdsimmodel.
}


//---------------------------------------------------------------------------


// CMAX31855App
//     . MAX31855.cpp
class CMAX31855App : public CWinApp
{
public:
	CMAX31855App();

// 
public:
	virtual BOOL InitInstance();

	DECLARE_MESSAGE_MAP()
};
