//------- Max_conv.CPP ---------------------------------------------------------------
#pragma once
#include "stdafx.h"
#include "Max_conv.h"	//-       .
//#include "Max_graf.h"
//------------------------------------------------------------------------------------





//------------------------------------------------------------------------------------
//   
INT Max_conv::isanalog(CHAR *pinname)
{
	if((strcmp(pinname, "T+")==0)||(strcmp(pinname, "T-")==0))
		return 1;	// 1 =     
	else 			// 1      .
		return 0;	// 0       .
}					// -1     ,   ,    .
//   
INT Max_conv::isdigital(CHAR *pinname)
{
	if((strcmp(pinname, "CS")==0)||(strcmp(pinname, "CLK")==0)||(strcmp(pinname, "SDO")==0))
		return 1;
	else
		return 0;
}
//------------------------------------------------------------------------------------
//   
VOID Max_conv::setup(IINSTANCE *instance, ISPICECKT *dsimckt)
{
	inst = instance;					// ,     
	ckt = dsimckt;						//   .

//       IINSTANCE::getdsimpin,     ,     .
	PinTP = inst->getspicenode("T+", true);	//       
	PinTM = inst->getspicenode("T-", true);	// Pin2    "C"
//   
	instance->getnumval(&res_val, "RESIST", 1000);
}
//   
VOID Max_conv::setup(IINSTANCE* instd, IDSIMCKT *dsim)
{
	instd_ = instd;					// ,     
	cktd = dsim;					//   .

	PinCS = instd_->getdsimpin("CS", true);		// CS    
	PinSCK = instd_->getdsimpin("CLK", true);	//
	PinSDO = instd_->getdsimpin("SDO", true);	//

//    : (   ,     "Q"  "0")
	PinSDO->setstate(SLO);				// Strong Low  SLO: Logic 0 active output.
										// Floating    FLT   Floating output - high-impedance.
										// Power High  PHI   Logic 1 power rail.
										// Power Low   PLO   Logic 0 power rail.
	new_flag = TRUE;					//---   
// 10 \-12 = 1, \-9 = 1, \-6 = 1, \-3 = 1
	re_time = false;
	cktd->setcallback(200000000000, this, 0x25);	//    (event) 0x25.      FFDEVICE::callback (time, eventid)
}
//------------------------------------------------------------------------------------





//---- DEVICE::runctrl ------------------------------------------------------------------
//    PROSPICE        .      ,   
//    .            ,    
//     .         ,      .
//---     (RUNMODES mode):
//		RM_BATCH=-1,		// BATCH-    ;
//		RM_START,			//     () .
//		RM_STOP,			//   (  )
//		RM_SUSPEND,			//   (  );
//		RM_ANIMATE,			//   ;
//---       :
//		RM_STEPTIME,		//  STEP()  
//		RM_STEPOVER,		//  "  "(Step Over command)
//		RM_STEPINTO,		//  "  " (Step Into command)
//		RM_STEPOUT,			//  "  "(Step Out command)
//		RM_STEPTO			//  "  "(Step To command)
//---    ,     CPU  .
VOID Max_conv::runctrl(RUNMODES mode)
{
	//    VOID IINSTANCE::log(CHAR *msg, ...)  ,    log- .
	// : if (instance) instance->log ("DIGONLY::runctrl() called with mode=%d:%s", mode, EnumToRunCtrl(mode));
	//         :
	// BOOL IINSTANCE::message(CHAR *msg, ...) -      ISIS.
}
//------------------------------------------------------------------------------------







//---- DEVICE::actuate ------------------------------------------------------------------
//   PROSPICE         ,  
//  .. (  ).            
//      ,         .
VOID Max_conv::actuate(REALTIME time, ACTIVESTATE newstate)
{
//   (ACTIVESTATE newstate)
//	IACTIVEMODEL* gmod;
//	ICOMPONENT* component;
//	gmod = instance->getactivemodel();
//	gmod->initialize(component);

//	IACTIVEMODEL* gmod;		getactivemodel();
//	IINSTANCE* ins;
	CHAR* ch;
	ch = instd_->getstrval("STEP", "NONE");		// NONE value(); // MAX31855_MDF //id(); // DA1_DA1 // getstrval("SETPOINT", "NONE");
	ch = instd_->getstrval("SETPOINT", "NONE");	//  t
//	ch = inst->getstrval("VALUE", "NONE");		// 1
//	ch = inst->getstrval("MAX", "NONE");		// NONE
//	ch = inst->getstrval("MIN", "NONE");		// NONE
//	ch = inst->value();							// 1

	inst->log(ch);

	if(newstate != -1)
		new_flag = true;
}
//------------------------------------------------------------------------------------








//---- DEVICE::indicate ------------------------------------------------------------------
//    PROSPICE     .        
//          . 
BOOL Max_conv::indicate(REALTIME time, ACTIVEDATA* data)
{
	//   (ACTIVEDATA *data).        (.VSMSDK.HLP). 
	if(new_flag) //---   
	{
		new_flag = false;
		data->type = ADT_REAL; //---   floating point number
		data->realval = (float)time * DSIMTICK; //---  (float) time*DSIMTICK
	}
	return TRUE;
}
//------------------------------------------------------------------------------------













//       .         . 
//  time -    , mode -  , oldrhs -     , 
// newrhs -  .       ,     .
VOID Max_conv::dcload(REALTIME time, SPICEMODES mode, DOUBLE *oldrhs, DOUBLE *newrhs)
{
}
//------------------------------------------------------------------------------------






//      .     dcload,    ,   
//      .  rhs -   , irhs -   . , 
//      ,          IINSTANE::error.
VOID Max_conv::acload(SPICEFREQ omega, DOUBLE *rhs, DOUBLE *irhs)
{
}
//------------------------------------------------------------------------------------






//    .           
// ISPIccEccKT::sysvar(SPIccEDELTA).  ,    ,     timestep too small. 
//          SPIccEccKT::sysvar(SPIccEDELMIN).
VOID Max_conv::trunc(REALTIME time,  REALTIME *newtimestep)
{
}
//------------------------------------------------------------------------------------






//           RHS.      . 
//      ,      = rhs[node].     ,   
//  ISPIccEccKT::newcurnode,      . -         
// .           ,      .
VOID Max_conv::accept(REALTIME time, DOUBLE *rhs)
{
	if(re_time == true)
	{
		re_time = false;
		voltage = rhs[PinTP] - rhs[PinTM];		//   
		if(voltage != oldvoltege)				//   
		{
			oldvoltege = voltage;
			temp_ex = voltage * 24480 +1;			//  
			new_flag = true;
		//	temp_ex = 0-temp_ex;				//  "-"
		}
	}
}
//------------------------------------------------------------------------------------








//---- DEVICE::simulate ------------------------------------------------------------------
//    DSIM               .
//           ,   IDSIMPIN      
// IDSIMPIN::setstate,        .     ,   
//   ,   IDSIMCKT::setcallback.   (DSIMMODES = BOOT,     . 
//       "simulate"   .)
VOID Max_conv::simulate (ABSTIME time, DSIMMODES mode)
{

//	Pin3->setstate(time, 1, Pin1->istate());	//         (istate()),     
//  Pin4->setstate(time, 1, Pin2->istate());	//    (setstate()):      Pin1  Pin2,   1 "" 
												// ,         Pin3  Pin4.
}
//------------------------------------------------------------------------------------








//---- DEVICE::callback ------------------------------------------------------------------
//        IDSIMCKT::setcallback  ,    , , , 
// ,       ,  IDSIMCKT::setcallback .
VOID Max_conv::callback(ABSTIME time, EVENTID eventid)
{
	if(eventid == 0x25)		//     :
	{
		re_time = true;
		if(ishigh(PinSDO->istate()))				//    ,      ,
		{
			PinSDO->setstate(time, 1, SLO);			//      1 ,     
													//   (callback).
		} else {
			PinSDO->setstate(time, 1, SHI);
			
		}
		cktd->setcallback(time + 100000000000, this, 0x25);
	}
}


