//-----   Max_conv.h ------------------------------------
#pragma once
#include "vsm.hpp"


/*class Max_conv : public IDSIMMODEL
{
 public:
   INT isdigital (CHAR *pinname);
   VOID setup (IINSTANCE *inst, IDSIMCKT *dsim);
   VOID runctrl (RUNMODES mode);
   VOID actuate (REALTIME time, ACTIVESTATE newstate);
   BOOL indicate (REALTIME time, ACTIVEDATA *data);
   VOID simulate (ABSTIME time, DSIMMODES mode);
   VOID callback (ABSTIME time, EVENTID eventid);
 private:
   IINSTANCE *inst;
   IDSIMCKT *ckt;
   IDSIMPIN *PinTP;
   IDSIMPIN *PinTM;
   IDSIMPIN *PinCS;
   IDSIMPIN *PinSCK;
   IDSIMPIN *PinSDO;
};*/

class Max_conv : public IMIXEDMODEL
{
 public:
	 INT isanalog(CHAR *pinname);
	 INT isdigital(CHAR *pinname);
	 VOID runctrl(RUNMODES mode);
	 VOID actuate(REALTIME time, ACTIVESTATE newstate);
	 BOOL indicate(REALTIME time, ACTIVEDATA *data);
	 VOID setup(IINSTANCE* inst, ISPICECKT *dsim);
	 VOID setup(IINSTANCE* instd, IDSIMCKT *dsim);
	 VOID dcload(REALTIME time, SPICEMODES mode, DOUBLE *oldrhs, DOUBLE *newrhs);
	 VOID acload(SPICEFREQ omega, DOUBLE *rhs, DOUBLE *irhs);
	 VOID trunc(REALTIME time,  REALTIME *newtimestep);
	 VOID accept(REALTIME time, DOUBLE *rhs);
	 VOID simulate (ABSTIME time, DSIMMODES mode);
	 VOID callback (ABSTIME time, EVENTID eventid);

 private:
	 IINSTANCE* inst;		//    
	 ISPICECKT* ckt;
	 IINSTANCE* instd_;		//    
	 IDSIMCKT* cktd;
	 
	 SPICENODE PinTP;		//  
	 SPICENODE PinTM;
	 IDSIMPIN* PinCS;		//  
	 IDSIMPIN* PinSCK;
	 IDSIMPIN* PinSDO;

	 DOUBLE	res_val;		//   

	 DOUBLE *node11, *node22, *node12, *node21;
	 DOUBLE voltage, oldvoltege;
	 BOOL re_time;
	 DWORD temp_ex;
	 BOOL new_flag;			//-   

};
